//
//  Animation.cpp
//
#include <math.h>
#include "wx/wx.h"
#include "resource.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif
#include "wx/radiobut.h"
#include "wx/listctrl.h"
#include "wx/button.h"
#include "wx/dialog.h"
double abs(double a);

enum{
	ANIM_LIST=0,
	ANIM_IN,
	ANIM_OUT,
	ANIM_CLICK,
	ANIM_SOON,
	ANIM_FADE,
	ANIM_RIGHT,
	ANIM_LEFT,
	ANIM_TOP,
	ANIM_BOTTOM,
	ANIM_EFFECTON,
	ANIM_EFFECTOFF,
	ANIM_DELETE,
	ANIM_UP,
	ANIM_DOWN,
	ANIM_OK,
	ANIM_CANCEL,
	ANIM_MAX
};

// 0 : fade , 1 : right , 2 : left , 3 : top , 4 : bottom
enum{
	DIR_FADE=0,
	DIR_RIGHT,
	DIR_LEFT,
	DIR_TOP,
	DIR_BOTTOM
};

class AnimationDialog : public wxDialog
{
public:
	// ctor
	AnimationDialog(MyFrame* parent);

	MyCanvas* grandparent;
	wxListCtrl *Line;
	wxRadioButton *B1a,*B1b,*B2a,*B2b,*B3a,*B3b,*B3c,*B3d,*B3e,*B4a,*B4b;
	wxButton *C1,*C2,*C3,*C4,*C5;
	GConst* entry[100];
	int direction[100],effect[100],inout[100],click[100];
	int maxphase,NOentry;
	int idx;
	void OnDelete(wxCommandEvent& event);
	void OnUp(wxCommandEvent& event);
	void OnDown(wxCommandEvent& event);
	void OnItemFocused(wxListEvent& event);
	void OnIn(wxCommandEvent& event);
	void OnOut(wxCommandEvent& event);
	void OnClick(wxCommandEvent& event);
	void OnSoon(wxCommandEvent& event);
	void OnFade(wxCommandEvent& event);
	void OnRight(wxCommandEvent& event);
	void OnLeft(wxCommandEvent& event);
	void OnTop(wxCommandEvent& event);
	void OnBottom(wxCommandEvent& event);
	void OnEffecton(wxCommandEvent& event);
	void OnEffectoff(wxCommandEvent& event);

private:
	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(AnimationDialog, wxDialog)
	EVT_BUTTON (ANIM_DELETE,	AnimationDialog::OnDelete)
	EVT_BUTTON (ANIM_UP,		AnimationDialog::OnUp)
	EVT_BUTTON (ANIM_DOWN,		AnimationDialog::OnDown)
	EVT_LIST_ITEM_FOCUSED(ANIM_LIST, AnimationDialog::OnItemFocused)
	EVT_RADIOBUTTON(ANIM_IN, AnimationDialog::OnIn)
	EVT_RADIOBUTTON(ANIM_OUT, AnimationDialog::OnOut)
	EVT_RADIOBUTTON(ANIM_CLICK, AnimationDialog::OnClick)
	EVT_RADIOBUTTON(ANIM_SOON, AnimationDialog::OnSoon)
	EVT_RADIOBUTTON(ANIM_FADE, AnimationDialog::OnFade)
	EVT_RADIOBUTTON(ANIM_RIGHT, AnimationDialog::OnRight)
	EVT_RADIOBUTTON(ANIM_LEFT, AnimationDialog::OnLeft)
	EVT_RADIOBUTTON(ANIM_TOP, AnimationDialog::OnTop)
	EVT_RADIOBUTTON(ANIM_BOTTOM, AnimationDialog::OnBottom)
	EVT_RADIOBUTTON(ANIM_EFFECTON, AnimationDialog::OnEffecton)
	EVT_RADIOBUTTON(ANIM_EFFECTOFF, AnimationDialog::OnEffectoff)
END_EVENT_TABLE()


#ifdef __WXMSW__
AnimationDialog::AnimationDialog(MyFrame *parent)
:wxDialog((wxWindow*)parent,wxID_ANY,AnimationPropertyTitle,wxPoint(50,50),wxSize(380,400),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	grandparent = parent->m_canvas;
	Line = new wxListCtrl(this,ANIM_LIST,wxPoint(10,30),wxSize(350,150),wxLC_LIST | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL,
		wxDefaultValidator, wxT("List"));
	B1a  = new wxRadioButton(this,ANIM_IN,AnimDlogLabels[ANIM_IN],wxPoint(10,190),wxSize(100,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B1b  = new wxRadioButton(this,ANIM_OUT,AnimDlogLabels[ANIM_OUT],wxPoint(120,190),wxSize(100,25), 0 , wxDefaultValidator, wxT("button"));
	B2a  = new wxRadioButton(this,ANIM_SOON,AnimDlogLabels[ANIM_SOON],wxPoint(10,220),wxSize(100,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B2b  = new wxRadioButton(this,ANIM_CLICK,AnimDlogLabels[ANIM_CLICK],wxPoint(120,220),wxSize(100,25), 0 , wxDefaultValidator, wxT("button"));
	B3a  = new wxRadioButton(this,ANIM_FADE,AnimDlogLabels[ANIM_FADE],wxPoint(10,250),wxSize(55,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B3b  = new wxRadioButton(this,ANIM_RIGHT,AnimDlogLabels[ANIM_RIGHT],wxPoint(70,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B3c  = new wxRadioButton(this,ANIM_LEFT,AnimDlogLabels[ANIM_LEFT],wxPoint(130,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B3d  = new wxRadioButton(this,ANIM_TOP,AnimDlogLabels[ANIM_TOP],wxPoint(190,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B3e  = new wxRadioButton(this,ANIM_BOTTOM,AnimDlogLabels[ANIM_BOTTOM],wxPoint(250,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B4a  = new wxRadioButton(this,ANIM_EFFECTOFF,AnimDlogLabels[ANIM_EFFECTOFF],wxPoint(10,280),wxSize(100,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B4b  = new wxRadioButton(this,ANIM_EFFECTON,AnimDlogLabels[ANIM_EFFECTON],wxPoint(120,280),wxSize(100,25), 0 , wxDefaultValidator, wxT("button"));
	C1 = new wxButton(this,ANIM_DELETE,AnimDlogLabels[ANIM_DELETE],wxPoint(10,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C2 = new wxButton(this,ANIM_UP,AnimDlogLabels[ANIM_UP],wxPoint(80,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C3 = new wxButton(this,ANIM_DOWN,AnimDlogLabels[ANIM_DOWN],wxPoint(150,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C4 = new wxButton(this,wxID_OK,AnimDlogLabels[ANIM_OK],wxPoint(220,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C5 = new wxButton(this,wxID_CANCEL,AnimDlogLabels[ANIM_CANCEL],wxPoint(290,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	NOentry=0;	
	maxphase=0;
	idx=-1;
}
#else
AnimationDialog::AnimationDialog(MyFrame *parent)
:wxDialog((wxWindow*)parent,wxID_ANY,AnimationPropertyTitle,wxPoint(50,50),wxSize(450,360),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	grandparent = parent->m_canvas;
	Line = new wxListCtrl(this,ANIM_LIST,wxPoint(10,30),wxSize(410,150),wxLC_LIST/* | wxLC_ALIGN_LEFT*/ | wxLC_SINGLE_SEL,
		wxDefaultValidator, wxT("List"));
	B1a  = new wxRadioButton(this,ANIM_IN,AnimDlogLabels[ANIM_IN],wxPoint(10,190),wxSize(130,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B1b  = new wxRadioButton(this,ANIM_OUT,AnimDlogLabels[ANIM_OUT],wxPoint(150,190),wxSize(130,25), 0 , wxDefaultValidator, wxT("button"));
	B2a  = new wxRadioButton(this,ANIM_SOON,AnimDlogLabels[ANIM_SOON],wxPoint(10,220),wxSize(130,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B2b  = new wxRadioButton(this,ANIM_CLICK,AnimDlogLabels[ANIM_CLICK],wxPoint(150,220),wxSize(130,25), 0 , wxDefaultValidator, wxT("button"));
	B3a  = new wxRadioButton(this,ANIM_FADE,AnimDlogLabels[ANIM_FADE],wxPoint(10,250),wxSize(70,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B3b  = new wxRadioButton(this,ANIM_RIGHT,AnimDlogLabels[ANIM_RIGHT],wxPoint(85,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B3c  = new wxRadioButton(this,ANIM_LEFT,AnimDlogLabels[ANIM_LEFT],wxPoint(160,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B3d  = new wxRadioButton(this,ANIM_TOP,AnimDlogLabels[ANIM_TOP],wxPoint(235,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B3e  = new wxRadioButton(this,ANIM_BOTTOM,AnimDlogLabels[ANIM_BOTTOM],wxPoint(310,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B4a  = new wxRadioButton(this,ANIM_EFFECTOFF,AnimDlogLabels[ANIM_EFFECTOFF],wxPoint(10,280),wxSize(130,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B4b  = new wxRadioButton(this,ANIM_EFFECTON,AnimDlogLabels[ANIM_EFFECTON],wxPoint(150,280),wxSize(130,25), 0 , wxDefaultValidator, wxT("button"));
	C1 = new wxButton(this,ANIM_DELETE,AnimDlogLabels[ANIM_DELETE],wxPoint(10,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C2 = new wxButton(this,ANIM_UP,AnimDlogLabels[ANIM_UP],wxPoint(95,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C3 = new wxButton(this,ANIM_DOWN,AnimDlogLabels[ANIM_DOWN],wxPoint(180,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C4 = new wxButton(this,wxID_OK,AnimDlogLabels[ANIM_OK],wxPoint(265,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C5 = new wxButton(this,wxID_CANCEL,AnimDlogLabels[ANIM_CANCEL],wxPoint(350,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	NOentry=0;	
	maxphase=0;
	idx=-1;
}
#endif

void AnimationDialog::OnDelete(wxCommandEvent& event)
{
	int i;
	char buff[2048];
	wxString str;
	if(idx>=0 && idx<maxphase){
		for(i=idx;i<maxphase-1;i++){
			entry[i]=entry[i+1];
			direction[i]=direction[i+1];
			effect[i]=effect[i+1];
			inout[i]=inout[i+1];
			click[i]=click[i+1];
		}
		maxphase--;
		Line->DeleteAllItems();
		for(i=0;i<maxphase;i++){
			entry[i]->ConstSrc(buff);
			str=wxString(buff,*wxConvCurrent);
			Line->InsertItem(i,str);
		}
	}
}

void AnimationDialog::OnUp(wxCommandEvent& event)
{
	char buff[2048];
	wxString str;
	if(idx>0){
		GConst* t_entry=entry[idx];
		int t_direction=direction[idx];
		int t_effect=effect[idx];
		int t_inout=inout[idx];
		int t_click=click[idx];
		entry[idx]=entry[idx-1];
		direction[idx]=direction[idx-1];
		effect[idx]=effect[idx-1];
		inout[idx]=inout[idx-1];
		click[idx]=click[idx-1];
		entry[idx-1]=t_entry;
		direction[idx-1]=t_direction;
		effect[idx-1]=t_effect;
		inout[idx-1]=t_inout;
		click[idx-1]=t_click;
		Line->DeleteAllItems();
		for(int i=0;i<maxphase;i++){
			entry[i]->ConstSrc(buff);
			str=wxString(buff,*wxConvCurrent);
			Line->InsertItem(i,str);
		}
	}
}

void AnimationDialog::OnDown(wxCommandEvent& event)
{
	char buff[2048];
	wxString str;
	if(idx<maxphase-1){
		GConst* t_entry=entry[idx];
		int t_direction=direction[idx];
		int t_effect=effect[idx];
		int t_inout=inout[idx];
		int t_click=click[idx];
		entry[idx]=entry[idx+1];
		direction[idx]=direction[idx+1];
		effect[idx]=effect[idx+1];
		inout[idx]=inout[idx+1];
		click[idx]=click[idx+1];
		entry[idx+1]=t_entry;
		direction[idx+1]=t_direction;
		effect[idx+1]=t_effect;
		inout[idx+1]=t_inout;
		click[idx+1]=t_click;
		Line->DeleteAllItems();
		for(int i=0;i<maxphase;i++){
			entry[i]->ConstSrc(buff);
			str=wxString(buff,*wxConvCurrent);
			Line->InsertItem(i,str);
		}
	}
}

void AnimationDialog::OnItemFocused(wxListEvent& event)
{
	idx=event.GetIndex();
	if(idx<0 || idx>maxphase){
		return;
	}
	switch(click[idx]){
	case 0:
		B2a->SetValue(true);
		break;
	case 1:
		B2b->SetValue(true);
		break;
	}
	switch(direction[idx]){
	case 0:
		B3a->SetValue(true);
		break;
	case 1:
		B3b->SetValue(true);
		break;
	case 2:
		B3c->SetValue(true);
		break;
	case 3:
		B3d->SetValue(true);
		break;
	case 4:
		B3e->SetValue(true);
		break;
	}
	switch(effect[idx]){
	case 0:
		B4a->SetValue(true);
		break;
	case 1:
		B4b->SetValue(true);
		break;
	}
	switch(inout[idx]){
	case 0:
		B1a->SetValue(true);
		break;
	case 1:
		B1b->SetValue(true);
		break;
	}

}

void AnimationDialog::OnIn(wxCommandEvent& event)
{
	if(idx>=0){
		inout[idx]=0;
	}
}

void AnimationDialog::OnOut(wxCommandEvent& event)
{
	if(idx>=0){
		inout[idx]=1;
	}
}

void AnimationDialog::OnClick(wxCommandEvent& event)
{
	if(idx>=0){
		click[idx]=1;
	}
}

void AnimationDialog::OnSoon(wxCommandEvent& event)
{
	if(idx>=0){
		click[idx]=0;
	}
}

void AnimationDialog::OnFade(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=0;
	}
}

void AnimationDialog::OnRight(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=1;
	}
}

void AnimationDialog::OnLeft(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=2;
	}
}

void AnimationDialog::OnTop(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=3;
	}
}

void AnimationDialog::OnBottom(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=4;
	}
}

void AnimationDialog::OnEffecton(wxCommandEvent& event)
{
	if(idx>=0){
		effect[idx]=1;
	}
}

void AnimationDialog::OnEffectoff(wxCommandEvent& event)
{
	if(idx>=0){
		effect[idx]=0;
	}
}

void MyCanvas::AnimationProperty()
{
	AnimationDialog MyD(m_owner);
	GConst* cnp;
	char buff[2048];
	int maxphase=0;
	bool add_item;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Const_Type){
		case CONST_EFFECT_POINT:
		case CONST_EFFECT_LINE:
		case CONST_EFFECT_CIRCLE:
		case CONST_EFFECT_CURVE:
		case CONST_EFFECT_TEXT:
		case CONST_EFFECT_ANGLE:
		case CONST_EFFECT_IMAGE:
		case CONST_EFFECT_BRACKET:
			cnp->anim_entry->ConstSrc(buff);
			wxString str(buff,*wxConvCurrent);
			MyD.Line->InsertItem(maxphase,str);
			MyD.entry[maxphase]=cnp->anim_entry;
			MyD.click[maxphase]=cnp->anim_click;
			MyD.direction[maxphase]=cnp->anim_direction;
			MyD.effect[maxphase]=cnp->anim_effect;
			MyD.inout[maxphase]=cnp->anim_inout;
			maxphase++;
			break;
		}
	}
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		add_item=false;
		switch(cnp->Output_Type()){
		case OUTPUT_POINT:
			if(cnp->POutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_LINE:
			if(cnp->LOutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_TEXT:
			if(cnp->TextOutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_CIRCLE:
			if(cnp->COutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_CURVE:
			if(cnp->CurveOutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_ANGLE:
			if(cnp->AngleOutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_IMAGE:
			if(cnp->ImageOutput->hilighted){ add_item=true; }
			break;
		case OUTPUT_BRACKET:
			if(cnp->BracketOutput->hilighted){ add_item=true; }
			break;
		}
		if(add_item){
			cnp->ConstSrc(buff);
			wxString str(buff,*wxConvCurrent);
			MyD.Line->InsertItem(maxphase,str);
			MyD.entry[maxphase]=cnp;
			MyD.click[maxphase]=0;
			MyD.direction[maxphase]=0;
			MyD.effect[maxphase]=0;
			MyD.inout[maxphase]=0;
			maxphase++;
		}
	}
	MyD.maxphase=maxphase;
	if(MyD.ShowModal()==wxID_OK)
	{
		ClearConstEffect();
		int i;
		for(i=0;i<MyD.maxphase;i++){
			AddConstEffect(MyD.entry[i],MyD.click[i],MyD.direction[i],MyD.effect[i],MyD.inout[i]);
		}
	}
}

void MyCanvas::AddConstEffect(GConst* entry, int click, int direction, int effect, int inout)
{
	GConst*cnp=NULL;
	switch(entry->Output_Type()){
	case OUTPUT_POINT:
		cnp=NewConst(CONST_EFFECT_POINT);
		break;
	case OUTPUT_LINE:
		cnp=NewConst(CONST_EFFECT_LINE);
		break;
	case OUTPUT_CIRCLE:
		cnp=NewConst(CONST_EFFECT_CIRCLE);
		break;
	case OUTPUT_TEXT:
		cnp=NewConst(CONST_EFFECT_TEXT);
		break;
	case OUTPUT_CURVE:
		cnp=NewConst(CONST_EFFECT_CURVE);
		break;
	case OUTPUT_ANGLE:
		cnp=NewConst(CONST_EFFECT_ANGLE);
		break;
	case OUTPUT_IMAGE:
		cnp=NewConst(CONST_EFFECT_IMAGE);
		break;
	case OUTPUT_BRACKET:
		cnp=NewConst(CONST_EFFECT_BRACKET);
		break;
	}
	cnp->anim_entry=entry;
	cnp->anim_inout=inout;
	cnp->anim_click=click;
	cnp->anim_direction=direction;
	cnp->anim_effect=effect;
	WriteLogFile(wxString::Format(wxT("  click=%d,direction=%d,effect=%d,inout=%d\n"),click,direction,effect,inout));
}

void MyCanvas::ClearConstEffect()
{
	if(cns==NULL){
		return ; 
	}
	GConst *cnp;
	GConst **cnh;
	cnh=&cns;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Const_Type){
		case CONST_EFFECT_POINT:
		case CONST_EFFECT_LINE:
		case CONST_EFFECT_CIRCLE:
		case CONST_EFFECT_CURVE:
		case CONST_EFFECT_TEXT:
		case CONST_EFFECT_ANGLE:
		case CONST_EFFECT_IMAGE:
		case CONST_EFFECT_BRACKET:
			cnp->used=false;
			*cnh=cnp->next;
			if(cnp->next==NULL){
				lastcn=cnh;
			}
			break;
		default:
			cnh=&(cnp->next);
			break;
		}
	}
}

double min(double a, double b){
	return(a>b)?b:a;
}
double max(double a, double b){
	return(a<b)?b:a;
}
int  imin(int  a, int  b){
	return(a>b)?b:a;
}
int  imax(int  a, int  b){
	return(a<b)?b:a;
}

bool MyCanvas::Init_anim_entry(GConst* cnp)
{
	double geomx;
	double geomy;
	double dispx0;
	double dispy0;
	double dispx1;
	double dispy1;
	int dispx;
	int dispy;
	int length,height;
	int x,y,r;
	int tx,ty;
	int r_off,l_off,t_off,b_off;
	wxPaintDC pDC(this);
	CComplex sxz,syz,exz,eyz;
	switch(cnp->Const_Type){
	case CONST_EFFECT_POINT:
		anim_cn=cnp;
		//printf("SlideShowStart:CONST_EFFECT_POINT\n");
		anim_wait=(cnp->anim_click==1);
		geomx=cnp->anim_entry->POutput->xz().real();
		geomy=cnp->anim_entry->POutput->yz().real();
		dispx=centerx+(int)floor((geomx-geomcx)/geomperdot);
		dispy=centery-(int)floor((geomy-geomcy)/geomperdot);
		pDC.SetFont(wxFont(cnp->anim_entry->POutput->_fontsize, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
		GetMultiTextSize(cnp->anim_entry->POutput->_name,(wxMemoryDC*) &pDC, &length, &height);
		tx=dispx+(int)floor((10+cnp->anim_entry->POutput->_fontsize)*cos(cnp->anim_entry->POutput->_name_theta))-(cnp->anim_entry->POutput->_fontsize/2);
		ty=dispy-(int)floor((10+cnp->anim_entry->POutput->_fontsize)*sin(cnp->anim_entry->POutput->_name_theta))-(cnp->anim_entry->POutput->_fontsize);
		cnp->anim_entry->POutput->expand=1.0;
		cnp->anim_entry->POutput->interval=0.2;
		cnp->anim_entry->POutput->hilighted=false;
		cnp->anim_entry->POutput->r_off=r_off=relRect.GetRight()-imin(dispx,tx)+30;
		cnp->anim_entry->POutput->l_off=l_off=relRect.GetLeft()-imax(dispx,tx+length)-30;
		cnp->anim_entry->POutput->t_off=t_off=relRect.GetTop()-imax(dispy,ty+height)-30;
		cnp->anim_entry->POutput->b_off=b_off=relRect.GetBottom()-imin(dispy,ty)+30;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE:	cnp->anim_entry->POutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT:	cnp->anim_entry->POutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:	cnp->anim_entry->POutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:	cnp->anim_entry->POutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->POutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE:	cnp->anim_entry->POutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->POutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->POutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->POutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->POutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		return true;
		break;
	case CONST_EFFECT_LINE:
		cnp->anim_entry->LOutput->hilighted=false;
		anim_cn=cnp;
		if(cnp->anim_click==1){
			anim_wait=true;
		}
		else{
			anim_wait=false;
		}
		GetGeomXY(cnp->anim_entry->LOutput, &dispx0, &dispy0, &dispx1, &dispy1);
		cnp->anim_entry->LOutput->expand=1.0;
		cnp->anim_entry->LOutput->interval=0.2;
		cnp->anim_entry->LOutput->r_off=r_off=relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30;
		cnp->anim_entry->LOutput->l_off=l_off=relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30;
		cnp->anim_entry->LOutput->t_off=t_off=relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30;
		cnp->anim_entry->LOutput->b_off=b_off=relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->LOutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->LOutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->LOutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->LOutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->LOutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->LOutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->LOutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->LOutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->LOutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->LOutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		return true;
		break;	
	case CONST_EFFECT_TEXT:
		PrepareDC(pDC);
		m_owner->PrepareDC(pDC);
		GetMultiTextSize(cnp->anim_entry->TextOutput->str,(wxMemoryDC*) &pDC, &length, &height);
		cnp->anim_entry->TextOutput->hilighted=false;
		anim_cn=cnp;
		if(cnp->anim_click==1){
			anim_wait=true;
		}
		else{
			anim_wait=false;
		}
		cnp->anim_entry->TextOutput->expand=1.0;
		cnp->anim_entry->TextOutput->interval=0.2;
		tx=(int)floor(cnp->anim_entry->TextOutput->tx);
		ty=(int)floor(cnp->anim_entry->TextOutput->ty);
		cnp->anim_entry->TextOutput->r_off=r_off=relRect.GetRight()-tx+30;
		cnp->anim_entry->TextOutput->l_off=l_off=relRect.GetLeft()-tx-length-30;
		cnp->anim_entry->TextOutput->t_off=t_off=relRect.GetTop()-ty-height-30;
		cnp->anim_entry->TextOutput->b_off=b_off=relRect.GetBottom()-ty+30;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->TextOutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->TextOutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->TextOutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->TextOutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->TextOutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->TextOutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->TextOutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->TextOutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->TextOutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->TextOutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		return true;
		break;
	case CONST_EFFECT_CIRCLE:
		cnp->anim_entry->COutput->hilighted=false;
		anim_cn=cnp;
		anim_wait=(cnp->anim_click==1);
		x=centerx+(int)floor((cnp->anim_entry->COutput->xx.real()-geomcx)/geomperdot);
		y=centery-(int)floor((cnp->anim_entry->COutput->yy.real()-geomcy)/geomperdot);
		r=(int)floor(cnp->anim_entry->COutput->rr.real()/geomperdot);
		cnp->anim_entry->COutput->expand=1.0;
		cnp->anim_entry->COutput->interval=0.2;
		cnp->anim_entry->COutput->r_off=r_off=relRect.GetRight()-x+r+30;
		cnp->anim_entry->COutput->l_off=l_off=relRect.GetLeft()-x-r-30;
		cnp->anim_entry->COutput->t_off=t_off=relRect.GetTop()-y-r-30;
		cnp->anim_entry->COutput->b_off=b_off=relRect.GetBottom()-y+r+30;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->COutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->COutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->COutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->COutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->COutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->COutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->COutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->COutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->COutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->COutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		return true;
		break;	
	case CONST_EFFECT_CURVE:
		cnp->anim_entry->CurveOutput->hilighted=false;
		anim_cn=cnp;
		anim_wait = (cnp->anim_click==1);
		cnp->anim_entry->CurveOutput->expand=1.0;
		cnp->anim_entry->CurveOutput->interval=0.2;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->CurveOutput->SetOffset(4,0,0,0); break;
			default: cnp->anim_entry->CurveOutput->SetOffset(0,0,0,0); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->CurveOutput->SetOffset(0,0,0,0); break;
			default: cnp->anim_entry->CurveOutput->SetOffset(0,0,0,0); break;
			}
		}
		return true;
		break;
	case CONST_EFFECT_ANGLE:
		cnp->anim_entry->AngleOutput->hilighted=false;
		anim_cn=cnp;
		anim_wait=(cnp->anim_click==1);
		geomx=cnp->anim_entry->AngleOutput->m_xx.real();
		geomy=cnp->anim_entry->AngleOutput->m_yy.real();
		dispx=centerx+(int)floor((geomx-geomcx)/geomperdot);
		dispy=centery-(int)floor((geomy-geomcy)/geomperdot);
		cnp->anim_entry->AngleOutput->expand=1.0;
		cnp->anim_entry->AngleOutput->interval=0.2;
		cnp->anim_entry->AngleOutput->r_off=r_off=relRect.GetRight()-dispx+cnp->anim_entry->AngleOutput->m_angle_size+30;
		cnp->anim_entry->AngleOutput->l_off=l_off=relRect.GetLeft()-dispx-cnp->anim_entry->AngleOutput->m_angle_size-30;
		cnp->anim_entry->AngleOutput->t_off=t_off=relRect.GetTop()-dispy-cnp->anim_entry->AngleOutput->m_angle_size-30;
		cnp->anim_entry->AngleOutput->b_off=b_off=relRect.GetBottom()-dispy+cnp->anim_entry->AngleOutput->m_angle_size+30;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->AngleOutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->AngleOutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->AngleOutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->AngleOutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->AngleOutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->AngleOutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->AngleOutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->AngleOutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->AngleOutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->AngleOutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		//printf("SlideShowStart : CONST_EFFECT_ANGLE : end\n");
		return true;
		break;
	case CONST_EFFECT_IMAGE:
		cnp->anim_entry->ImageOutput->hilighted=false;
		anim_cn=cnp;
		//printf("FindNextEffectFromCns:CONST_EFFECT_TEXT\n");
		anim_wait = (cnp->anim_click==1);
		cnp->anim_entry->ImageOutput->expand=1.0;
		cnp->anim_entry->ImageOutput->interval=0.2;
		cnp->anim_entry->ImageOutput->r_off=r_off=relRect.GetRight()-cnp->anim_entry->ImageOutput->m_x+30;
		cnp->anim_entry->ImageOutput->l_off=l_off=relRect.GetLeft()-cnp->anim_entry->ImageOutput->m_x-cnp->anim_entry->ImageOutput->m_w-30;
		cnp->anim_entry->ImageOutput->t_off=t_off=relRect.GetTop()-cnp->anim_entry->ImageOutput->m_y-cnp->anim_entry->ImageOutput->m_h-30;
		cnp->anim_entry->ImageOutput->b_off=b_off=relRect.GetBottom()-cnp->anim_entry->ImageOutput->m_y+30;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->ImageOutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->ImageOutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->ImageOutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->ImageOutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->ImageOutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE: 	cnp->anim_entry->ImageOutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->ImageOutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->ImageOutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->ImageOutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->ImageOutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		return true;
		break;
	case CONST_EFFECT_BRACKET:
		//printf("Init_anim_entry : CONST_EFFECT_BRACKET\n");
		anim_cn=cnp;
		sxz=cnp->anim_entry->BracketOutput->m_startx/cnp->anim_entry->BracketOutput->m_startz;
		syz=cnp->anim_entry->BracketOutput->m_starty/cnp->anim_entry->BracketOutput->m_startz;
		exz=cnp->anim_entry->BracketOutput->m_endx/cnp->anim_entry->BracketOutput->m_endz;
		eyz=cnp->anim_entry->BracketOutput->m_endy/cnp->anim_entry->BracketOutput->m_endz;
		if(!(sxz.realp()) || !(syz.realp()) || !(exz.realp()) || !(eyz.realp())){
			cnp->anim_entry->BracketOutput->SetOffset(0,0,0,0); 
			return false;
		}
		geomx=sxz.real();
		geomy=syz.real();
		dispx0=1.0*centerx+(geomx-geomcx)/geomperdot;
		dispy0=1.0*centery-(geomy-geomcy)/geomperdot;
		geomx=exz.real();
		geomy=eyz.real();
		dispx1=1.0*centerx+(geomx-geomcx)/geomperdot;
		dispy1=1.0*centery-(geomy-geomcy)/geomperdot;
		anim_wait = (cnp->anim_click==1);
		double d,ax,ay,sn,dh,r0,cx,cy,dx,dy;
		d=sqrt(1.0*(dispx0-dispx1)*(dispx0-dispx1)+1.0*(dispy0-dispy1)*(dispy0-dispy1));
		dx=ax=0.5*(dispx0+dispx1);
		dy=ay=0.5*(dispy0+dispy1);
		sn=(cnp->anim_entry->BracketOutput->m_bracket_height>0)? 1.0 : -1.0;
		dh=abs(d*cnp->anim_entry->BracketOutput->m_bracket_height);
		if(dh==0.0){ dh=0.001; }
		r0=(dh*dh+d*d*0.25)/(2*dh);
		if(r0==dh){ r0=dh+0.001; } 
		cx=ax-sn*(dispy0-dispy1)/d*(r0-dh);
		cy=ay+sn*(dispx0-dispx1)/d*(r0-dh);
		if((dispx0<cx && cx<dispx1) || (dispx1<cx && cx<dispx0)){
			dy = (dispy0<cy)? cy-r0 : cy+r0;
			//printf("Init_anim_entry : ,dispy0,dispy1,dy=%f,%f,%f\n",dispy0,dispy1,dy);
		}
		if((dispy0<cy && cy<dispy1) || (dispy1<cy && cy<dispy0)){
			dx = (dispx0<cx)? cx-r0 : cx+r0;
			//printf("Init_anim_entry : ,dispx0,dispx1,dx=%f,%f,%f\n",dispx0,dispx1,dx);
		}
		cnp->anim_entry->BracketOutput->expand=1.0;
		cnp->anim_entry->BracketOutput->interval=0.2;
		cnp->anim_entry->BracketOutput->r_off=r_off=relRect.GetRight() -(int)floor(min(dx,min(dispx0,dispx1)))+30;
		cnp->anim_entry->BracketOutput->l_off=l_off=relRect.GetLeft()  -(int)floor(max(dx,max(dispx0,dispx1)))-30;
		cnp->anim_entry->BracketOutput->t_off=t_off=relRect.GetTop()   -(int)floor(max(dy,max(dispy0,dispy1)))-30;
		cnp->anim_entry->BracketOutput->b_off=b_off=relRect.GetBottom()-(int)floor(min(dy,min(dispy0,dispy1)))+30;
		//printf("Top   =%d\n",relRect.GetTop());
		//printf("Bottom=%d\n",relRect.GetBottom());
		//printf("Init_anim_entry : (r,l,t,b)=(%d,%d,%d,%d)\n",r_off,l_off,t_off,b_off);

		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE:	cnp->anim_entry->BracketOutput->SetOffset(4,0,0,0); break;
			case DIR_RIGHT:	cnp->anim_entry->BracketOutput->SetOffset(0,r_off,0,r_off/10); break;
			case DIR_LEFT:	cnp->anim_entry->BracketOutput->SetOffset(0,l_off,0,l_off/10); break;
			case DIR_TOP:	cnp->anim_entry->BracketOutput->SetOffset(0,0,t_off,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->BracketOutput->SetOffset(0,0,b_off,b_off/10); break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE:	cnp->anim_entry->BracketOutput->SetOffset(0,0,0,0); break;
			case DIR_RIGHT: cnp->anim_entry->BracketOutput->SetOffset(0,0,0,r_off/10); break;
			case DIR_LEFT:  cnp->anim_entry->BracketOutput->SetOffset(0,0,0,l_off/10); break;
			case DIR_TOP:   cnp->anim_entry->BracketOutput->SetOffset(0,0,0,t_off/10); break;
			case DIR_BOTTOM:cnp->anim_entry->BracketOutput->SetOffset(0,0,0,b_off/10); break;
			}
		}
		return true;
		break;
	}
	return false;
}

void MyCanvas::SlideShowStart(GConst* cnp)
{
	if(cnp->next!=NULL){
		SlideShowStart(cnp->next);
	}
	Init_anim_entry(cnp);
}

void MyCanvas::Animnext()
{
	if(anim_cn==NULL){
		anim_wait=true;
		return;
	}
	int *vanishing=NULL,*velocity=NULL;
	double *expand=NULL,*interval=NULL;
	int *offsetx=NULL,*offsety=NULL;
	int r_off=0,l_off=0,t_off=0,b_off=0;
	switch(anim_cn->Const_Type){
	case CONST_EFFECT_POINT:
		r_off=anim_cn->anim_entry->POutput->r_off;
		l_off=anim_cn->anim_entry->POutput->l_off;
		t_off=anim_cn->anim_entry->POutput->t_off;
		b_off=anim_cn->anim_entry->POutput->b_off;
		vanishing = &(anim_cn->anim_entry->POutput->vanishing);
		expand = &(anim_cn->anim_entry->POutput->expand);
		interval = &(anim_cn->anim_entry->POutput->interval);
		velocity = &(anim_cn->anim_entry->POutput->velocity);
		offsetx = &(anim_cn->anim_entry->POutput->offsetx);
		offsety = &(anim_cn->anim_entry->POutput->offsety);
		break;
	case CONST_EFFECT_LINE:
		r_off=anim_cn->anim_entry->LOutput->r_off;
		l_off=anim_cn->anim_entry->LOutput->l_off;
		t_off=anim_cn->anim_entry->LOutput->t_off;
		b_off=anim_cn->anim_entry->LOutput->b_off;
		vanishing = &(anim_cn->anim_entry->LOutput->vanishing);
		expand = &(anim_cn->anim_entry->LOutput->expand);
		interval = &(anim_cn->anim_entry->LOutput->interval);
		velocity = &(anim_cn->anim_entry->LOutput->velocity);
		offsetx = &(anim_cn->anim_entry->LOutput->offsetx);
		offsety = &(anim_cn->anim_entry->LOutput->offsety);
		break;
	case CONST_EFFECT_TEXT:
		r_off=anim_cn->anim_entry->TextOutput->r_off;
		l_off=anim_cn->anim_entry->TextOutput->l_off;
		t_off=anim_cn->anim_entry->TextOutput->t_off;
		b_off=anim_cn->anim_entry->TextOutput->b_off;
		vanishing = &(anim_cn->anim_entry->TextOutput->vanishing);
		expand = &(anim_cn->anim_entry->TextOutput->expand);
		interval = &(anim_cn->anim_entry->TextOutput->interval);
		velocity = &(anim_cn->anim_entry->TextOutput->velocity);
		offsetx = &(anim_cn->anim_entry->TextOutput->offsetx);
		offsety = &(anim_cn->anim_entry->TextOutput->offsety);
		break;
	case CONST_EFFECT_CIRCLE:
		r_off=anim_cn->anim_entry->COutput->r_off;
		l_off=anim_cn->anim_entry->COutput->l_off;
		t_off=anim_cn->anim_entry->COutput->t_off;
		b_off=anim_cn->anim_entry->COutput->b_off;
		vanishing = &(anim_cn->anim_entry->COutput->vanishing);
		expand = &(anim_cn->anim_entry->COutput->expand);
		interval = &(anim_cn->anim_entry->COutput->interval);
		velocity = &(anim_cn->anim_entry->COutput->velocity);
		offsetx = &(anim_cn->anim_entry->COutput->offsetx);
		offsety = &(anim_cn->anim_entry->COutput->offsety);
		break;
	case CONST_EFFECT_CURVE:
		r_off=0;
		l_off=0;
		t_off=0;
		b_off=0;
		vanishing = &(anim_cn->anim_entry->CurveOutput->vanishing);
		expand = &(anim_cn->anim_entry->CurveOutput->expand);
		interval = &(anim_cn->anim_entry->CurveOutput->interval);
		velocity = &(anim_cn->anim_entry->CurveOutput->velocity);
		offsetx = &(anim_cn->anim_entry->CurveOutput->offsetx);
		offsety = &(anim_cn->anim_entry->CurveOutput->offsety);
		break;
	case CONST_EFFECT_ANGLE:
		r_off=anim_cn->anim_entry->AngleOutput->r_off;
		l_off=anim_cn->anim_entry->AngleOutput->l_off;
		t_off=anim_cn->anim_entry->AngleOutput->t_off;
		b_off=anim_cn->anim_entry->AngleOutput->b_off;
		vanishing = &(anim_cn->anim_entry->AngleOutput->vanishing);
		expand = &(anim_cn->anim_entry->AngleOutput->expand);
		interval = &(anim_cn->anim_entry->AngleOutput->interval);
		velocity = &(anim_cn->anim_entry->AngleOutput->velocity);
		offsetx = &(anim_cn->anim_entry->AngleOutput->offsetx);
		offsety = &(anim_cn->anim_entry->AngleOutput->offsety);
		break;
	case CONST_EFFECT_IMAGE:
		r_off=anim_cn->anim_entry->ImageOutput->r_off;
		l_off=anim_cn->anim_entry->ImageOutput->l_off;
		t_off=anim_cn->anim_entry->ImageOutput->t_off;
		b_off=anim_cn->anim_entry->ImageOutput->b_off;
		vanishing = &(anim_cn->anim_entry->ImageOutput->vanishing);
		expand = &(anim_cn->anim_entry->ImageOutput->expand);
		interval = &(anim_cn->anim_entry->ImageOutput->interval);
		velocity = &(anim_cn->anim_entry->ImageOutput->velocity);
		offsetx = &(anim_cn->anim_entry->ImageOutput->offsetx);
		offsety = &(anim_cn->anim_entry->ImageOutput->offsety);
		break;
	case CONST_EFFECT_BRACKET:
		r_off=anim_cn->anim_entry->BracketOutput->r_off;
		l_off=anim_cn->anim_entry->BracketOutput->l_off;
		t_off=anim_cn->anim_entry->BracketOutput->t_off;
		b_off=anim_cn->anim_entry->BracketOutput->b_off;
		vanishing = &(anim_cn->anim_entry->BracketOutput->vanishing);
		expand = &(anim_cn->anim_entry->BracketOutput->expand);
		interval = &(anim_cn->anim_entry->BracketOutput->interval);
		velocity = &(anim_cn->anim_entry->BracketOutput->velocity);
		offsetx = &(anim_cn->anim_entry->BracketOutput->offsetx);
		offsety = &(anim_cn->anim_entry->BracketOutput->offsety);
		//printf("Animnext : CONST_EFFECT_BRACKET : %s\n",anim_cn->anim_entry->BracketOutput->_name.c_str());
		break;
	}
	//printf("anim_cn->anim_inout=%d\n",anim_cn->anim_inout);
	//printf("anim_cn->anim_direction=%d\n",anim_cn->anim_direction);
	//printf("(*offsetx)=%d\n",(*offsetx));
	//printf("(*offsety)=%d\n",(*offsety));
	//printf("(*velocity)=%d\n",(*velocity));
	if(anim_cn->anim_inout==0){
		switch(anim_cn->anim_direction){
		case DIR_FADE:
			if(anim_cn->anim_effect==0){
				(*vanishing) --;
				if((*vanishing) <= 0){
					(*vanishing) = 0;
					FindNextEffectFromCns();
				}
			}
			else {
				if((*vanishing) > 0){
					(*vanishing) --;
				}
				else {
					(*vanishing) = 0;
					(*expand) += (*interval);
					if((*expand)>=2.0){
						(*interval) *= -1;
					}
					if((*expand) <= 1.0 && (*interval) <0){
						(*expand)=1.0;
						FindNextEffectFromCns();
					}
				}
			}
			break;
		case DIR_RIGHT:
			if(anim_cn->anim_effect==0){
				(*offsetx) -= (*velocity);
				if((*offsetx) < 0){
					(*offsetx) = 0;
					FindNextEffectFromCns();
				}
			}
			else {
				if((*offsetx) > 0){
					(*offsetx) -= (*velocity);
					if((*offsetx) < 0){
						(*offsetx) = 0;
					}
				}
				else {
					(*offsetx) = 0;
					(*expand) += (*interval);
					if((*expand) >= 2.0){
						(*interval) *= -1;
					}
					if((*expand) <= 1.0 && (*interval) < 0){
						(*expand) = 1.0;
						FindNextEffectFromCns();
					}
				}
			}
			break;
		case DIR_LEFT:
			if(anim_cn->anim_effect==0){
				(*offsetx) -= (*velocity);
				if((*offsetx) > 0){
					(*offsetx) = 0;
					FindNextEffectFromCns();
				}
			}
			else {
				if((*offsetx) < 0){
					(*offsetx) -= (*velocity);
					if((*offsetx) > 0){
						(*offsetx) = 0;
					}
				}
				else {
					(*offsetx) = 0;
					(*expand) += (*interval);
					if((*expand) >= 2.0){
						(*interval) *= -1;
					}
					if((*expand) <= 1.0 && (*interval) < 0){
						(*expand) = 1.0;
						FindNextEffectFromCns();
					}
				}
			}
			break;
		case DIR_TOP:
			if(anim_cn->anim_effect==0){
				(*offsety) -= (*velocity);
				if((*offsety) > 0){
					(*offsety) = 0;
					FindNextEffectFromCns();
				}
			}
			else {
				if((*offsety)<0){
					(*offsety) -= (*velocity);
					if((*offsety) > 0){
						(*offsety) = 0;
					}
				}
				else {
					(*offsety)=0;
					(*expand) += (*interval);
					if((*expand) >= 2.0){
						(*interval) *= -1;
					}
					if((*expand) <= 1.0 && (*interval) < 0){
						(*expand) = 1.0;
						FindNextEffectFromCns();
					}
				}
			}
			break;
		case DIR_BOTTOM:
			if(anim_cn->anim_effect==0){
				(*offsety) -= (*velocity);
				if((*offsety) < 0){
					(*offsety) = 0;
					FindNextEffectFromCns();
				}
			}
			else {
				if((*offsety) > 0){
					(*offsety) -= (*velocity);
					if((*offsety) < 0){
						(*offsety) = 0;
					}
				}
				else {
					(*offsety) = 0;
					(*expand) += (*interval);
					if((*expand) >= 2.0){
						(*interval) *= -1;
					}
					if((*expand) <= 1.0 && (*interval) < 0){
						(*expand) = 1.0;
						FindNextEffectFromCns();
					}
				}
			}
			break;
		}
	}
	else{
		switch(anim_cn->anim_direction){
		case DIR_FADE:
			if(anim_cn->anim_effect==0 || (*vanishing) > 0){
				(*vanishing) ++;
				if((*vanishing) >= 5){
					(*vanishing) = 5;
					FindNextEffectFromCns();
				}
			}
			else {
				(*expand) += (*interval);
				if((*expand) >= 2.0){
					(*interval) *= -1;
				}
				if((*expand) <= 1.0 && (*interval) < 0){
					(*expand) = 1.0;
					(*vanishing) = 1;
				}
			}
			break;
		case DIR_RIGHT:
			if(anim_cn->anim_effect==0 || (*offsetx)>0){
				(*offsetx) += (*velocity);
				if((*offsetx) > r_off){
					(*offsetx) = r_off;
					FindNextEffectFromCns();
				}
			}
			else {
				(*expand) += (*interval);
				if((*expand) >= 2.0){
					(*interval) *= -1;
				}
				if((*expand) <= 1.0 && (*interval) < 0){
					(*expand) = 1.0;
					(*offsetx) = (*velocity);
				}
			}
			break;
		case DIR_LEFT:
			if(anim_cn->anim_effect==0 || (*offsetx) < 0){
				(*offsetx) += (*velocity);
				if((*offsetx) < l_off){
					(*offsetx) = l_off;
					FindNextEffectFromCns();
				}
			}
			else {
				(*expand) += (*interval);
				if((*expand) >= 2.0){
					(*interval) *= -1;
				}
				if((*expand) <= 1.0 && (*interval) <0){
					(*expand) = 1.0;
					(*offsetx) = (*velocity);
				}
			}
			break;
		case DIR_TOP:
			if(anim_cn->anim_effect==0 || (*offsety) < 0){
				(*offsety) += (*velocity);
				if((*offsety) < t_off){
					(*offsety) = t_off;
					FindNextEffectFromCns();
				}
			}
			else {
				(*expand) += (*interval);
				if((*expand) >= 2.0){
					(*interval) *= -1;
				}
				if((*expand) <= 1.0 && (*interval) < 0){
					(*expand) = 1.0;
					(*offsety) = (*velocity);
				}
			}
			break;
		case DIR_BOTTOM:
			if(anim_cn->anim_effect==0 || (*offsety) > 0){
				(*offsety) += (*velocity);
				if((*offsety)>b_off){
					(*offsety)=b_off;
					FindNextEffectFromCns();
				}
			}
			else {
				(*expand) += (*interval);
				if((*expand) >= 2.0){
					(*interval) *= -1;
				}
				if((*expand) <= 1.0 && (*interval) < 0){
					(*expand) = 1.0;
					(*offsety) = (*velocity);
				}
			}
			break;
		}
	}
}
