#ifndef __CCOMPLEX__
#define __CCOMPLEX__

class CComplex
{
public:
	double re;
	double im;
	CComplex(void);
	CComplex(double r,double i);
	CComplex(const CComplex &z);
	~CComplex(void);
	CComplex& operator =(const CComplex& a);
	friend CComplex operator +(const CComplex& a,const CComplex& b);
	friend CComplex operator -(const CComplex& a,const CComplex& b);
	friend CComplex operator *(const CComplex& a,const CComplex& b);
	friend CComplex operator /(const CComplex& a,const CComplex& b);
	CComplex operator +=(const CComplex& a);
	CComplex operator -=(const CComplex& a);
	CComplex operator *=(const CComplex& a);
	CComplex operator /=(const CComplex& a);
	CComplex operator /=(const double a);
	friend bool operator == (const CComplex& a,const CComplex&b);
	friend bool operator != (const CComplex& a,const CComplex&b);
	bool zerop();
	friend bool zerop(CComplex z);
	double real(void);
	double imag(void);
	void SetComplex(double r, double im);
	bool realp(void);
	friend double supnorm(CComplex z);
	friend double norm2(CComplex z);
	friend double norm1(CComplex z);
	friend CComplex sqrtC(CComplex x);
	friend CComplex conjugate(CComplex x);
};

#endif
