//
// Find.cpp 
//
#include <math.h>
#include "wx/wx.h"
#include "incident.h"
#include "resource.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

// 0 : fade , 1 : right , 2 : left , 3 : top , 4 : bottom
enum{
	DIR_FADE=0,
	DIR_RIGHT,
	DIR_LEFT,
	DIR_TOP,
	DIR_BOTTOM
};

bool MyCanvas::FindAnotherMeet(GCircle* ci1, GLine *ln1,GPoint ** ptH)
{
	GIncident*ic1,*ic2;
	for(ic1=ci1->ics;ic1!=NULL;ic1=ic1->_icnext){
		for(ic2=ln1->ics;ic2!=NULL;ic2=ic2->_icnext){
			if(ic1->_icpt == ic2->_icpt){
				*ptH =ic1->_icpt;
				return true;
			}
		}
	}
	*ptH=NULL;
	return false;
}

bool MyCanvas::FindAnotherMeet(GCircle* ci1, GCircle *ci2,GPoint ** ptH)
{
	GIncident*ic1,*ic2;
	for(ic1=ci1->ics;ic1!=NULL;ic1=ic1->_icnext){
		for(ic2=ci2->ics;ic2!=NULL;ic2=ic2->_icnext){
			if(ic1->_icpt == ic2->_icpt){
				*ptH =ic1->_icpt;
				return true;
			}
		}
	}
	*ptH=NULL;
	return false;
}

bool MyCanvas::FindJoinFromCns(GConst* cn,GPoint* pt1,GPoint*pt2,GConst** cn1)
{
	if(cn==NULL){
		return false;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_JOIN && cncur->PInput1==pt1 && cncur->PInput2==pt2){
			*cn1 = cncur;
			return true;
		}
		if(cncur->Const_Type==CONST_JOIN && cncur->PInput1==pt2 && cncur->PInput2==pt1){
			*cn1 = cncur;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindMeetFromCn(GConst* cn,GLine* ln1,GLine* ln2,GConst **cn1)
{
	if(cn==NULL){
		return true;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_MEET && cncur->LInput1==ln1 && cncur->LInput2==ln2){
			*cn1 = cncur;
			return false;
		}
		else if(cncur->Const_Type==CONST_MEET && cncur->LInput1==ln2 && cncur->LInput2==ln1){
			*cn1 = cncur;
			return false;
		}
	}
	return true;
}

bool FindNameFromCns(GConst* cn,wxString& name,GConst** cn1)
{
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->COutput!=NULL){
			//printf("(%s==%s)=%d:",cnp->COutput->_name.c_str(),name.c_str(),(int)(mStrcmp(cnp->COutput->_name,name)));
			if(mStrcmp(cnp->COutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->LOutput!=NULL){
			if(mStrcmp(cnp->LOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->POutput!=NULL){
			//printf("(%s==%s)=%d:",cnp->POutput->_name.c_str(),name.c_str(),(int)(mStrcmp(cnp->POutput->_name,name)));
			if(mStrcmp(cnp->POutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->CurveOutput!=NULL){
			if(mStrcmp(cnp->CurveOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->TextOutput!=NULL){
			if(mStrcmp(cnp->TextOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->AngleOutput!=NULL){
			if(mStrcmp(cnp->AngleOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
		if(cnp->BracketOutput!=NULL){
			if(mStrcmp(cnp->BracketOutput->_name,name)){
				*cn1=cnp;
				return true;
			}
		}
	}
	return false;
}

bool MyCanvas::FindParaFromCns(GConst* cn,GLine* ln1,GPoint* pt1,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_PARALLEL && cncur->LInput1==ln1 && cncur->PInput1==pt1){
			*cn1 = cncur;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindPerpFromCns(GConst* cn,GLine* ln1,GPoint* pt1,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cncur;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->Const_Type==CONST_PERP && cncur->LInput1==ln1 && cncur->PInput1==pt1){
			*cn1 = cncur;
			return true;
		}
	}
	return false;
}

GPoint* MyCanvas::FindPtFromPts(GPoint* ptp,GPoint* pt){
	if(ptp==NULL || pt==NULL){
		return NULL;
	}
	if(ptp->xx * pt->yy==ptp->yy * pt->xx && ptp->yy * pt->zz==ptp->zz * pt->yy && ptp!=pt){
		return ptp;
	}
	else{
		return FindPtFromPts(ptp->next, pt);
	}
}
bool FindCiFromCn(GConst* cn,GCircle* ci,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}

	if(cn->COutput==ci){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindCiFromCn(cn->next,ci,cn1);
	}
	return false;
}




bool FindCnFromPt(GConst* cn,GPoint* pt,GConst** cn1)
{
	if(cn==NULL){
		return true;
	}
	GConst *cncur;
	*cn1=NULL;
	for(cncur=cn;cncur!=NULL;cncur=cncur->next){
		if(cncur->POutput==pt){
			*cn1 = cncur;
			return false;
		}
	}
	return true;
}

bool FindCurveFromCn(GConst* cn,GParaCurve* cu,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}
	if(cn->CurveOutput==cu){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindCurveFromCn(cn->next,cu,cn1);
	}
	return false;
}
bool FindAngleFromCn(GConst* cn,GAngle* ag,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}
	if(cn->AngleOutput==ag){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindAngleFromCn(cn->next,ag,cn1);
	}
	return false;
}

bool FindLnFromCn(GConst* cn,GLine* ln,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}

	if(cn->LOutput==ln){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindLnFromCn(cn->next,ln,cn1);
	}
	return false;
}

bool FindPtFromCn(GConst* cn,GPoint* pt,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}
	if(cn->POutput==pt){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindPtFromCn(cn->next,pt,cn1);
	}
	return false;
}


bool FindBrFromCn(GConst* cn,GBracket* br,GConst **cn1)
{
	if(cn==NULL){
		return false;
	}
	if(cn->BracketOutput==br){
		*cn1=cn;
		return true;
	}
	if(cn->next!=NULL){
		return FindBrFromCn(cn->next,br,cn1);
	}
	return false;
}


bool MyCanvas::Find3PBisectorFromCns(GConst* cn,GPoint* pt1,GPoint* pt2,GPoint* pt3,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_3P_BISECTOR && cnp->PInput1==pt1 && cnp->PInput2==pt2 && cnp->PInput3==pt3){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindBisectorFromCns(GConst* cn,GLine* ln1,GLine* ln2,double dd1,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_BISECTOR && cnp->LInput1==ln1 && cnp->LInput2==ln2 && cnp->para1==CComplex(dd1,0.0)){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindTangentFromCns(GConst* cn,GCircle* ci,GPoint* pt,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_TANGENT && cnp->CInput1==ci && cnp->PInput1==pt){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool FindCurveTangentFromCns(GConst* cn,GParaCurve* cu,GPoint* pt,GConst** cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_CURVE_TANGENT && cnp->CurveInput1==cu && cnp->PInput1==pt){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindLineWithAngleFromCns(GConst*cn,GLine*ln,GPoint*pt,GAngle*ag,GConst**cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_LINE_WITH_ANGLE && cnp->LInput1==ln && cnp->PInput1==pt && cnp->AngleInput1==ag){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}

bool MyCanvas::FindLineWithAngleDegreeFromCns(GConst*cn,GLine*ln,GPoint*pt,double ag,GConst**cn1)
{
	*cn1=NULL;
	if(cn==NULL){
		return false;
	}
	GConst *cnp;
	for(cnp=cn;cnp!=NULL;cnp=cnp->next){
		if(cnp->Const_Type==CONST_LINE_WITH_ANGLE_DEGREE && cnp->LInput1==ln && cnp->PInput1==pt && cnp->para1.real()-0.01<ag && ag<cnp->para1.real()+0.01){
			*cn1 = cnp;
			return true;
		}
	}
	return false;
}


bool MyCanvas::FindNextEffectFromCns()
{
	GConst *cnp;
	for(cnp=anim_cn->next;cnp!=NULL;cnp=cnp->next){
		if(Init_anim_entry(cnp)){
			return true;
		}
	}
	//printf("FindNextEffectFromCns:End of the page\n");
	anim_cn=NULL;
	return false;
}
