//
// GAngle.cpp
//

#include "wx/wx.h"
#include "KidsCindyCanvas.h"
#include "resource.h"
#include <math.h>

void GAngle::SetOffset(int van,int ox,int oy,int vel)
{
	vanishing=van;
	offsetx=ox;
	offsety=oy;
	velocity=vel;
}


GAngle* MyCanvas::NewAngle(CComplex x)
{
	int i;
	for(i=0;i<NUM_OF_BUFFER;i++){
		if(anglebuffer[i].used==false){
			anglebuffer[i].next=NULL;
			anglebuffer[i].used=true;
			anglebuffer[i].invisible=true;
			anglebuffer[i].m_angle_design=AngleMode-AG_1;
			anglebuffer[i].m_angle_size=40;
			anglebuffer[i].m_angle=x;
			anglebuffer[i].m_xx=CComplex(0.0,0.0);
			anglebuffer[i].m_yy=CComplex(0.0,0.0);
			anglebuffer[i].m_startx=CComplex(1.0,0.0);
			anglebuffer[i].m_starty=CComplex(0.0,0.0);
			anglebuffer[i].m_endx=CComplex(cos(x.real()),0.0);
			anglebuffer[i].m_endy=CComplex(sin(x.real()),0.0);
			anglebuffer[i].vanishing=0;
			anglebuffer[i].expand=1.0;
			anglebuffer[i].interval=0.2;
			return &(anglebuffer[i]);
		}
	}
	return NULL;
}

GAngle* MyCanvas::NewAngle(double x)
{
	int i;
	for(i=0;i<NUM_OF_BUFFER;i++){
		if(anglebuffer[i].used==false){
			anglebuffer[i].next=NULL;
			anglebuffer[i].used=true;
			anglebuffer[i].invisible=true;
			anglebuffer[i].m_angle_design=AngleMode-AG_1;
			anglebuffer[i].m_angle_size=40;
			anglebuffer[i].m_angle=CComplex(x,0.0);
			anglebuffer[i].m_xx=CComplex(0.0,0.0);
			anglebuffer[i].m_yy=CComplex(0.0,0.0);
			anglebuffer[i].m_startx=CComplex(1.0,0.0);
			anglebuffer[i].m_starty=CComplex(0.0,0.0);
			anglebuffer[i].m_endx=CComplex(cos(x),0.0);
			anglebuffer[i].m_endy=CComplex(sin(x),0.0);
			anglebuffer[i].vanishing=0;
			anglebuffer[i].expand=1.0;
			anglebuffer[i].interval=0.2;
			//anglebuffer[i].ColR=AngleColR[AngleMode];
			//anglebuffer[i].ColG=AngleColG[AngleMode];
			//anglebuffer[i].ColB=AngleColB[AngleMode];
			return &(anglebuffer[i]);
		}
	}
	return NULL;
}

void MyCanvas::AssignAngle(GAngle* ag)
{
	*lastag = ag;
	lastag= &(ag->next);
	sheetbuffer[currentSheet].MyAngle=ags;
	sheetbuffer[currentSheet].MyLastAngle=lastag;
}

void MyCanvas::SetAllAngleColor()
{
	for(GAngle* ag=ags;ag!=NULL;ag=ag->next){
		ag->ColR=AngleColR[ag->m_angle_design];
		ag->ColG=AngleColG[ag->m_angle_design];
		ag->ColB=AngleColB[ag->m_angle_design];
	}
}
bool MyCanvas::DeleteAllAngles(GAngle* ag)
{
	if(ag==NULL){
		return false;
	}
	DeleteAllAngles(ag->next);
	ag->used=false;
	return false;
}

//
//  GBrackets.cpp
//

void GBracket::SetOffset(int van,int ox,int oy,int vel)
{
	vanishing=van;
	offsetx=ox;
	offsety=oy;
	velocity=vel;
}

GBracket* MyCanvas::NewBracket(GPoint* pt1,GPoint* pt2)
{
	int i;
	for(i=0;i<NUM_OF_BUFFER;i++){
		if(bracketbuffer[i].used==false){
			bracketbuffer[i].next=NULL;
			bracketbuffer[i].used=true;
			bracketbuffer[i].invisible=false;
			bracketbuffer[i].m_bracket_design=0;
			bracketbuffer[i].m_bracket_height=0.3;
			bracketbuffer[i].m_startx=pt1->xx;
			bracketbuffer[i].m_starty=pt1->yy;
			bracketbuffer[i].m_startz=pt1->zz;
			bracketbuffer[i].m_endx=pt2->xx;
			bracketbuffer[i].m_endy=pt2->yy;
			bracketbuffer[i].m_endz=pt2->zz;
			bracketbuffer[i].caption=wxT("");
			bracketbuffer[i].vanishing=0;
			bracketbuffer[i].expand=1.0;
			bracketbuffer[i].interval=0.2;
			bracketbuffer[i].ColR=BracketColR;
			bracketbuffer[i].ColG=BracketColG;
			bracketbuffer[i].ColB=BracketColB;
			return &(bracketbuffer[i]);
		}
	}
	return NULL;
}

void MyCanvas::AssignBracket(GBracket* br)
{
	*lastbr = br;
	lastbr= &(br->next);
	sheetbuffer[currentSheet].MyBracket=brs;
	sheetbuffer[currentSheet].MyLastBracket=lastbr;
}

void MyCanvas::SetAllBracketColor()
{
	for(GBracket* br=brs;br!=NULL;br=br->next){
		br->ColR=BracketColR;
		br->ColG=BracketColG;
		br->ColB=BracketColB;
	}
}
bool MyCanvas::DeleteAllBrackets(GBracket* br)
{
	if(br==NULL){
		return false;
	}
	DeleteAllBrackets(br->next);
	br->used=false;
	return false;
}

