
#include "GCircle.h"

GCircle::GCircle(void)
{
	xx=CComplex(0.0,0.0);
	yy=CComplex(0.0,0.0);
	rr=CComplex(1.0,0.0);
}

GCircle::~GCircle(void)
{
}

GCircle::GCircle(CComplex x,CComplex y,CComplex r)
{
	xx=x;
	yy=y;
	rr=r;
}
GCircle::GCircle(double x1, double y1, double radius)
{
	xx=CComplex(x1,0.0);
	yy=CComplex(y1,0.0);
	rr=CComplex(radius,0.0);
}

GCircle::GCircle(const GCircle& p)
{
	xx=p.xx;
	yy=p.yy;
	rr=p.rr;
}

bool GCircle::SetCircle(double x1, double y1, double r1)
{
	xx=CComplex(x1,0.0);
	yy=CComplex(y1,0.0);
	rr=CComplex(r1,0.0);
	return false;
}
int GCircle::NumOfCc(void)
{
	if(next==NULL){
		return 1;
	}
	else {
		return (next->NumOfCc() + 1);
	}

}

bool GCircle::realp(double* rx,double* ry,double* rz)
{
	if(rr.zerop()){
		if(yy.zerop()){
			*rx=1.0;*ry=0.0;*rz=0.0;
			return true;
		}
		else {
			*rx=xx.real();
			*ry=yy.real();
			*rz=0.0;
			return (xx/yy).realp();
		}
	}
	else {

		*rx=xx.real();
		*ry=yy.real();
		*rz=rr.real();
		return ((xx/rr).realp()  && (yy/rr).realp());
	}
}

void GCircle::SetOffset(int van,int ox,int oy,int vel)
{
	vanishing=van;
	offsetx=ox;
	offsety=oy;
	velocity=vel;
}

#include "wx/wx.h"
#include "KidsCindyCanvas.h"

GCircle* MyCanvas::NewCircle(double cx,double cy,double cr)
{
	int i;
	for(i=0;i<NUM_OF_BUFFER;i++){
		if(circlebuffer[i].used==false){
			circlebuffer[i].xx=CComplex(cx,0.0);
			circlebuffer[i].yy=CComplex(cy,0.0);
			circlebuffer[i].rr=CComplex(cr,0.0);
			circlebuffer[i].next=NULL;
			circlebuffer[i].used=true;
			circlebuffer[i].vanishing=0;
			circlebuffer[i].invisible=false;
			circlebuffer[i].lndsn=LineMode-LN_1;
			circlebuffer[i].ics=NULL;
			circlebuffer[i].last_ic=&(circlebuffer[i].ics);
			circlebuffer[i].NOics=0;
			circlebuffer[i].offsetx=0;
			circlebuffer[i].offsety=0;
			circlebuffer[i].expand=1.0;
			circlebuffer[i].interval=0.2;
			return &(circlebuffer[i]);
		}
	}
	return NULL;
}
void MyCanvas::AssignCircle(GCircle* ci)
{
	*lastci = ci;
	lastci= &(ci->next);
	sheetbuffer[currentSheet].MyCircle=cis;
	sheetbuffer[currentSheet].MyLastCircle=lastci;
}

bool MyCanvas::DeleteAllCircles(GCircle* l)
{
	if(l==NULL){
		return false;
	}
	DeleteAllCircles(l->next);
	l->used=false;
	return false;
}
GCircle* MyCanvas::makeCClone(GCircle* l) // ܂
{
	if(l!=NULL){
		GCircle* tmp;
		tmp=NewCircle(l->xx.real(),l->yy.real(),l->rr.real());
		tmp->NOics=-999;  // UNDEFINITE CODE
		tmp->vanishing = l->vanishing + 1; 
		tmp->invisible=l->invisible;
		tmp->expand = l->expand;
		if(l->next!=NULL){
			tmp->next=makeCClone(l->next);
		}
		else {
			tmp->next=NULL;
		}
		return tmp;
	}
	return NULL;
}


bool MyCanvas::copyToCClone(GCircle* tgt,GCircle* src) // N[Ƀf[^Rs[
{
	// tgt->*** = src-> ***;// F𔖂ăRs[B炱N[B
	if(tgt==NULL || src==NULL){
		return false;
	}
	tgt->xx=src->xx;
	tgt->yy=src->yy;
	tgt->rr=src->rr;
	tgt->vanishing = src->vanishing + 1; 
	tgt->invisible=src->invisible;
	tgt->expand = src->expand;
	if(tgt->next!=NULL && src->next != NULL){
		return copyToCClone(tgt->next,src->next);
	}
	return false;
}

bool MyCanvas::deleteCClone(GCircle* l) // N[
{
	DeleteAllCircles(l);
	return false;
}
